Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Friends | List of all members
MacWrtParser Class Referencefinal

the main class to read a MacWrite file More...

`#include <MacWrtParser.hxx>`

Inheritance diagram for MacWrtParser:

## Public Member Functions
| MacWrtParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~MacWrtParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | sendWindow (int zone)
| send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER ) More...
bool | createZones ()
| finds the different objects zones More...
bool | createZonesV3 ()
| finds the different objects zones (version <= 3) More...
bool | readPrintInfo ()
| read the print info zone More...
bool | readWindowsInfo (int wh)
| read the windows zone More...
bool | readLinesHeight (MWAWEntry const &entry, std::vector< int > &firstParagLine, std::vector< int > &linesHeight)
| read the line height More...
bool | readInformationsV3 (int numInfo, std::vector< MacWrtParserInternal::Information > &informations)
| read the information ( version <= 3) More...
bool | readInformations (MWAWEntry const &entry, std::vector< MacWrtParserInternal::Information > &informations)
| read the information More...
bool | readParagraph (MacWrtParserInternal::Information const &info)
| read a paragraph More...
bool | readGraphic (MacWrtParserInternal::Information const &info)
| read a graphics More...
bool | readText (MacWrtParserInternal::Information const &info, std::vector< int > const &lineHeight)
| read a text zone More...
bool | readPageBreak (MacWrtParserInternal::Information const &info)
| read a page break zone ( version <= 3) More...
bool | checkFreeList ()
| check the free list More...
void | newPage (int number)
| adds a new page More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Static Protected Member Functions
static bool | isMagicPic (librevenge::RVNGBinaryData const &dt)
| test if a graphic is empty. More...

## Protected Attributes
std::shared_ptr< MacWrtParserInternal::State > | m_state
| the state More...

## Friends
class | MacWrtParserInternal::SubDocument

## Detailed Description

the main class to read a MacWrite file

## Constructor & Destructor Documentation

## ◆ MacWrtParser()

MacWrtParser::MacWrtParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~MacWrtParser()

MacWrtParser::~MacWrtParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkFreeList()

bool MacWrtParser::checkFreeList | ( |  | ) |
| protected

check the free list

Referenced by createZones().

## ◆ checkHeader()

bool MacWrtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void MacWrtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool MacWrtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ createZonesV3()

bool MacWrtParser::createZonesV3 | ( |  | ) |
| protected

finds the different objects zones (version <= 3)

Referenced by parse().

## ◆ init()

void MacWrtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MacWrtParser().

## ◆ isMagicPic()

bool MacWrtParser::isMagicPic | ( | librevenge::RVNGBinaryData const & | dt | ) |
| static protected

test if a graphic is empty.

In v5, some empty graphic are added before a page break, so it better to remove them

Referenced by readGraphic().

## ◆ newPage()

void MacWrtParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendWindow().

## ◆ parse()

void MacWrtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| final virtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readGraphic()

bool MacWrtParser::readGraphic | ( | MacWrtParserInternal::Information const & | info | ) |
| protected

read a graphics

Referenced by sendWindow().

## ◆ readInformations()

bool MacWrtParser::readInformations | ( | MWAWEntry const & | entry,
|  | std::vector< MacWrtParserInternal::Information > & | informations
| ) |  |
| protected

read the information

Referenced by readWindowsInfo().

## ◆ readInformationsV3()

bool MacWrtParser::readInformationsV3 | ( | int | numInfo,
|  | std::vector< MacWrtParserInternal::Information > & | informations
| ) |  |
| protected

read the information ( version <= 3)

Referenced by createZonesV3().

## ◆ readLinesHeight()

bool MacWrtParser::readLinesHeight | ( | MWAWEntry const & | entry,
|  | std::vector< int > & | firstParagLine,
|  | std::vector< int > & | linesHeight
| ) |  |
| protected

read the line height

Referenced by readText(), and readWindowsInfo().

## ◆ readPageBreak()

bool MacWrtParser::readPageBreak | ( | MacWrtParserInternal::Information const & | info | ) |
| protected

read a page break zone ( version <= 3)

Referenced by sendWindow().

## ◆ readParagraph()

bool MacWrtParser::readParagraph | ( | MacWrtParserInternal::Information const & | info | ) |
| protected

read a paragraph

Referenced by sendWindow().

## ◆ readPrintInfo()

bool MacWrtParser::readPrintInfo | ( |  | ) |
| protected

read the print info zone

Referenced by checkHeader(), createZones(), and createZonesV3().

## ◆ readText()

bool MacWrtParser::readText | ( | MacWrtParserInternal::Information const & | info,
|  | std::vector< int > const & | lineHeight
| ) |  |
| protected

read a text zone

Referenced by sendWindow().

## ◆ readWindowsInfo()

bool MacWrtParser::readWindowsInfo | ( | int | wh | ) |
| protected

read the windows zone

Referenced by checkHeader(), createZones(), and createZonesV3().

## ◆ sendWindow()

bool MacWrtParser::sendWindow | ( | int | zone | ) |
| protected

send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )

Referenced by createDocument(), and parse().

## Friends And Related Function Documentation

## ◆ MacWrtParserInternal::SubDocument

friend class MacWrtParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<MacWrtParserInternal::State> MacWrtParser::m_state
| protected

the state

Referenced by checkFreeList(), checkHeader(), createDocument(), createZones(), createZonesV3(), init(), newPage(), parse(), readText(), readWindowsInfo(), and sendWindow().

The documentation for this class was generated from the following files:

- MacWrtParser.hxx
- MacWrtParser.cxx